freemarker.ext.beans

## Class SimpleMapModel

- java.lang.Object
- - freemarker.template.WrappingTemplateModel
  - - freemarker.ext.beans.SimpleMapModel

All Implemented Interfaces:
  WrapperTemplateModel, AdapterTemplateModel, TemplateHashModel, TemplateHashModelEx, TemplateHashModelEx2, TemplateMethodModel, TemplateMethodModelEx, TemplateModel, TemplateModelWithAPISupport

    public class SimpleMapModel
    extends WrappingTemplateModel
    implements TemplateHashModelEx2, TemplateMethodModelEx, AdapterTemplateModel, WrapperTemplateModel, TemplateModelWithAPISupport

Model used by `BeansWrapper` when `simpleMapWrapper` mode is enabled. Provides a simple hash model interface to the underlying map (does not copy like `SimpleHash`), and a method interface to non-string keys.

### Nested Class Summary

### Nested classes/interfaces inherited from interface freemarker.template.TemplateHashModelEx2

`TemplateHashModelEx2.KeyValuePair, TemplateHashModelEx2.KeyValuePairIterator`

### Field Summary

### Fields inherited from interface freemarker.template.TemplateModel

`NOTHING`

### Constructor Summary

Constructors
Constructor and Description
`SimpleMapModel(Map map, BeansWrapper wrapper)`

### Method Summary

All Methods Instance Methods Concrete Methods
`Object` `exec(List args)` Executes the method call.
`TemplateModel` `get(String key)` Gets a `TemplateModel` from the hash.
`Object` `getAdaptedObject(Class hint)` Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
`TemplateModel` `getAPI()` Returns the model that exposes the (Java) API of the value.
`Object` `getWrappedObject()` Retrieves the original object wrapped by this model.
`boolean` `isEmpty()`
`TemplateCollectionModel` `keys()`
`TemplateHashModelEx2.KeyValuePairIterator` `keyValuePairIterator()`
`int` `size()`
`TemplateCollectionModel` `values()`

### Methods inherited from class freemarker.template.WrappingTemplateModel

`getDefaultObjectWrapper, getObjectWrapper, setDefaultObjectWrapper, setObjectWrapper, wrap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SimpleMapModel

    public SimpleMapModel(Map map,
                          BeansWrapper wrapper)

### Method Detail

#### get

    public TemplateModel get(String key)
                      throws TemplateModelException

Description copied from interface: `TemplateHashModel`
Gets a `TemplateModel` from the hash.

Specified by:
  `get` in interface `TemplateHashModel`
Parameters:
  `key` - the name by which the `TemplateModel` is identified in the template.
Returns:
  the `TemplateModel` referred to by the key, or null if not found.
Throws:
  `TemplateModelException`

#### exec

    public Object exec(List args)
                throws TemplateModelException

Description copied from interface: `TemplateMethodModelEx`
Executes the method call.

Specified by:
  `exec` in interface `TemplateMethodModel`
Specified by:
  `exec` in interface `TemplateMethodModelEx`
Parameters:
  `args` - a `List` of `TemplateModel`-s, containing the arguments passed to the method. If the implementation absolutely wants to operate on POJOs, it can use the static utility methods in the `DeepUnwrap` class to easily obtain them. However, unwrapping is not always possible (or not perfectly), and isn't always efficient, so it's recommended to use the original `TemplateModel` value as much as possible.
Returns:
  the return value of the method, or `null`. If the returned value does not implement `TemplateModel`, it will be automatically wrapped using the `environment's object wrapper`.
Throws:
  `TemplateModelException`

#### isEmpty

    public boolean isEmpty()

Specified by:
  `isEmpty` in interface `TemplateHashModel`

#### size

    public int size()

Specified by:
  `size` in interface `TemplateHashModelEx`
Returns:
  the number of key/value mappings in the hash.

#### keys

    public TemplateCollectionModel keys()

Specified by:
  `keys` in interface `TemplateHashModelEx`
Returns:
  a collection containing the keys in the hash. Every element of the returned collection must implement the `TemplateScalarModel` (as the keys of hashes are always strings).

#### values

    public TemplateCollectionModel values()

Specified by:
  `values` in interface `TemplateHashModelEx`
Returns:
  a collection containing the values in the hash. The elements of the returned collection can be any kind of `TemplateModel`-s.

#### keyValuePairIterator

    public TemplateHashModelEx2.KeyValuePairIterator keyValuePairIterator()

Specified by:
  `keyValuePairIterator` in interface `TemplateHashModelEx2`
Returns:
  The iterator that walks through the key-value pairs in the hash. Not `null`.

#### getAdaptedObject

    public Object getAdaptedObject(Class hint)

Description copied from interface: `AdapterTemplateModel`
Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.

Specified by:
  `getAdaptedObject` in interface `AdapterTemplateModel`
Parameters:
  `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
Returns:
  the underlying object, or its value accommodated for the hint class.

#### getWrappedObject

    public Object getWrappedObject()

Description copied from interface: `WrapperTemplateModel`
Retrieves the original object wrapped by this model.

Specified by:
  `getWrappedObject` in interface `WrapperTemplateModel`

#### getAPI

    public TemplateModel getAPI()
                         throws TemplateModelException

Description copied from interface: `TemplateModelWithAPISupport`
Returns the model that exposes the (Java) API of the value. This is usually implemented by delegating to `ObjectWrapperWithAPISupport.wrapAsAPI(Object)`.

Specified by:
  `getAPI` in interface `TemplateModelWithAPISupport`
Throws:
  `TemplateModelException`